//+------------------------------------------------------------------+
//|                                                  CandleClock.mq4 |
//|                                               -Frederick Lambert |
//|                                                                  | 
//|                                                                  | 
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008 FrederickLambert"
#property link      "fredericklambert@msn.com"

/*--------------------------------------------------------------------
Acknowledgements:  Nick Bilak for b-Clock.mq4 "Copyright  2005,
Nick Bilak, http://metatrader.50webs.com/" the inspiration for
CandleClock.mq4
--------------------------------------------------------------------*/

#property indicator_chart_window
extern color  TimeColor                     = Orange;
extern int    TimeFontSize                  = 9;
extern bool   Display_moving_on_bid_line?   = false;
extern bool   __Bracket_moving_display?     = false;
extern bool   Display_fixed_on_chart?       = true;
extern bool   __Bracket_fixed_display?      = false;
extern int    __Show_in_chart_window_0123   = 0;
extern int    __Show_in_window_corner_0123  = 3;            
extern int    ____Adjust_Vertical_Indent    = 15;    //Higher # increases space & must be =>0
extern int    ____Adjust_Horizontal_Indent  = 1;    //Higher # increases space & must be >0

extern string Change_heading_of_fixed_display  = "";

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {   
  }
   return(0);
//+------------------------------------------------------------------+
//| Custom indicator de-initialization function                         |
//+------------------------------------------------------------------+
int deinit()
{  
   int obj_total= ObjectsTotal();  
   for (int k= obj_total; k>=0; k--) 
      {
      string name= ObjectName(k);    
          if (StringSubstr(name,0,19)=="[CandleClockMoving]") { ObjectDelete(name); }
          if (StringSubstr(name,0,18)=="[CandleClockFixed]") { ObjectDelete(name); }
      }
}
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {	

//----Clear chart of any previous CandleClock labels----    
   int obj_total= ObjectsTotal();  
   for (int k= obj_total; k>=0; k--) 
      {
      string name= ObjectName(k);    
          if (StringSubstr(name,0,19)=="[CandleClockMoving]"){ObjectDelete(name);}
          if (StringSubstr(name,0,18)=="[CandleClockFixed]") { ObjectDelete(name); }
      }  

//----Get x,y co-ordinates for CandleClock labels, taking chart scale into consideration----
	double top = WindowPriceMax();
	double bottom = WindowPriceMin();
	double scale = top - bottom;	
	double Yadjust = scale/50;
   double H = ____Adjust_Horizontal_Indent; if (H <= 0) {H = 1;} 
   double V = ____Adjust_Vertical_Indent; if (V <= 0) {V = 1;} 
   double x = Time[0];
   double y = Close[0]+(scale/60);
	
//----Get time (H/M/S) remaining on current candle, use strings to fill missing zeros----		
	int i,h,m,s,t; 
	string L = "  "; string R = "  "; string spacer = ("                         ");
  
   t=Time[0]+(Period()*60)-CurTime();
   s=t%60; string seconds = (s); if (s<10) {seconds = ("0"+seconds);} 
   m=(t-t%60)/60;   
   for(i=0; i<24; i++)
   if(m>=60){m=m-60;h=h+1;}
   string minutes = (m); if (m<10) {minutes = ("0"+minutes);}   
   string hours = (h); if (h<10) {hours = ("0"+hours);} 
   string timeleft = (minutes+":"+seconds);
   if (h>=1) {timeleft = (hours+":"+minutes); spacer=spacer+"      ";}
 
//----Construct/reconstruct (move) CandleClock label fixed in chart corner---- 
   if (Display_fixed_on_chart? == true)
      {
      if (__Bracket_fixed_display? == true) {L = " [ "; R = " ]";}
      if(ObjectFind("[CandleClockFixed]") != 0)
         {
         ObjectCreate("[CandleClockFixed]", OBJ_LABEL, __Show_in_chart_window_0123, 0, 0);
         ObjectSet("[CandleClockFixed]", OBJPROP_CORNER, __Show_in_window_corner_0123 );
         ObjectSet("[CandleClockFixed]", OBJPROP_XDISTANCE, H);
         ObjectSet("[CandleClockFixed]", OBJPROP_YDISTANCE, V);
         ObjectSetText("[CandleClockFixed]",Change_heading_of_fixed_display+L
                             +timeleft+R,TimeFontSize,"Arial Bold",TimeColor);
         }
      else
         {
         ObjectMove("[CandleClockFixed]", __Show_in_chart_window_0123, H, V);
         }
      }
           	   	   
//----Construct/reconstruct (move) CandleClock label floating at bid----
   if (Display_moving_on_bid_line? == true)
      {
      if (__Bracket_moving_display? == true) {L = "<  "; R = "  ";}
      if(ObjectFind("[CandleClockMoving]") != 0)
         {
         ObjectCreate("[CandleClockMoving]", OBJ_TEXT, 0, x, y);
         ObjectSetText("[CandleClockMoving]", spacer + L + timeleft + R, TimeFontSize, "Arial Bold", TimeColor);
         }
      else
         {
         ObjectMove("[CandleClockMoving]", 0, x, y);
         }
      }
   return(0);
  }
//+------------------------------------------------------------------+


