//+------------------------------------------------------------------+
//|   AutoPivotIndicator.mq4          ver 4.02           by Habeeb   |
//|                                                                  |
//|          This version solves the Sunday Bar problem.             |
//| Ver4 calculated daily pivots incorrectly when Use_Sunday_Data    |
//|        was set to "False".  Fixed in this version.               |
//+------------------------------------------------------------------+
//  Candle Confluance Bar

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  Maroon
#property indicator_color3  LimeGreen
#property indicator_color4  Red
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  4
#property indicator_width4  4

   extern bool Use_Sunday_Data   = True;
   extern color DPC=DarkOrange;    extern color WPC=RoyalBlue;    extern color MPC=Black;
   
   extern bool  ShowBar   = True;
   extern int   CandleShift= 7;
   


   double DayHigh[];
   double DayLow[];
   double DayOpen[];
   double DayClose[];
   
   double YesterdayHigh,YesterdayLow,YesterdayClose,Pivot,Day_Price[][6];
      
   double WeekHigh,WeekLow,WeekClose,Weekly_Price[][6];
   double WeekPivot,WS1,WS2,WS3,WR1,WR2,WR3;
   
   double MonthHigh,MonthLow,MonthClose,Month_Price[][6];
   double MonthPivot,MS1,MS2,MS3,MR1,MR2,MR3;
   int	Arrow;
   color CCC;
   
   
int init()
{
   SetIndexBuffer(0, DayHigh);
   SetIndexBuffer(1, DayLow);
   SetIndexBuffer(2, DayClose);
   SetIndexBuffer(3, DayOpen);
   
      if (ShowBar)
         for (int i=0;i<4;i++)
            {
               SetIndexStyle(i,DRAW_HISTOGRAM);
               SetIndexShift(i,CandleShift);
               SetIndexLabel(i,"Daily data");
            }            
      else  for (i=0;i<4;i++) SetIndexStyle(i,DRAW_NONE);

   //


//  CANDLE CONFLUENCE
/*  
  if (iClose(NULL,PERIOD_D1,0) > iOpen(NULL,PERIOD_D1,0) && iClose(NULL,PERIOD_W1,0) > iOpen(NULL,PERIOD_W1,0) && iClose(NULL,PERIOD_MN1,0) > iOpen(NULL,PERIOD_MN1,0) )
   {Arrow = 233; CCC=Green;}
   
 else   if (iClose(NULL,PERIOD_D1,0) < iOpen(NULL,PERIOD_D1,0) && iClose(NULL,PERIOD_W1,0) < iOpen(NULL,PERIOD_W1,0) && iClose(NULL,PERIOD_MN1,0) < iOpen(NULL,PERIOD_MN1,0) )
  { Arrow = 234; CCC=Red;}
   
   else {Arrow = 232; CCC = Yellow;}
   
   
     
     ObjectCreate("CCA", OBJ_ARROW,0,0,0,0,0);
        ObjectSet("CCA", OBJPROP_ARROWCODE,  232);
        ObjectSet("CCA",OBJPROP_COLOR,CCC);
        ObjectSet("CCA", OBJPROP_CORNER, 2);
        ObjectSet("CCA", OBJPROP_STYLE, STYLE_SOLID);
        ObjectSet("CCA", OBJPROP_XDISTANCE, 10);
        ObjectSet("CCA", OBJPROP_YDISTANCE, 2);
*/        
//=================================================================================================================        

//Pivot = iOpen(NULL,PERIOD_D1,0);

   return(0);
  }
//-------------------------------------------------------- 

int deinit()
{
ObjectsDeleteAll(); 

return(0);
}
//--------------------------------------------------------- 

int start()


{
ArrayCopyRates(Day_Price,(Symbol()), 1440);
   YesterdayHigh  = Day_Price[1][3];
   YesterdayLow   = Day_Price[1][2];
   YesterdayClose = Day_Price[1][4];
   Pivot = ((YesterdayHigh + YesterdayLow + YesterdayClose)/3);

if (Use_Sunday_Data == false)
 {   
   while (DayOfWeek() == 1)
      {
       YesterdayHigh  = Day_Price[2][3];
       YesterdayLow   = Day_Price[2][2];
       YesterdayClose = Day_Price[2][4];
       Pivot = ((YesterdayHigh + YesterdayLow + YesterdayClose)/3);
       break;
      }
 }
  
//--------------------------------------------------------

ArrayCopyRates(Weekly_Price, Symbol(), 10080);
WeekHigh  = Weekly_Price[1][3];
WeekLow   = Weekly_Price[1][2];
WeekClose = Weekly_Price[1][4];
WeekPivot = ((WeekHigh + WeekLow + WeekClose)/3);
      WR1 = (2*WeekPivot)-WeekLow;
      WS1 = (2*WeekPivot)-WeekHigh;

      WR2 = WeekPivot+(WR1-WS1);
      WS2 = WeekPivot-(WR1-WS1);

      WS3 = (WeekLow - (2*(WeekHigh-WeekPivot)));
      WR3 = (WeekHigh + (2*(WeekPivot-WeekLow)));

ArrayCopyRates(Month_Price, Symbol(), 43200);
MonthHigh  = Month_Price[1][3];
MonthLow   = Month_Price[1][2];
MonthClose = Month_Price[1][4];
MonthPivot = ((MonthHigh + MonthLow + MonthClose)/3);
      MR1 = (2*MonthPivot)-MonthLow;
      MS1 = (2*MonthPivot)-MonthHigh;

      MR2 = MonthPivot+(MR1-MS1);
      MS2 = MonthPivot-(MR1-MS1);

      MS3 = (MonthLow - (2*(MonthHigh-MonthPivot)));
      MR3 = (MonthHigh + (2*(MonthPivot-MonthLow)));
      
//if (iClose(NULL,PERIOD_D1,0) > iOpen(NULL,PERIOD_D1,0) && iClose(NULL,PERIOD_W1,0) > iOpen(NULL,PERIOD_W1,0) && iClose(NULL,PERIOD_MN1,0) > iOpen(NULL,PERIOD_MN1,0) )
//Pivot = iOpen(NULL,PERIOD_D1,0);

      
      
/*

NULL, PERIOD_M30, 20, 0

iTime(NULL,PERIOD_D1,0)

ma20c = iMA(NULL, PERIOD_M30, 20, 0, ma_method, PRICE_CLOSE, i);
			ma20p1 = iMA(NULL, PERIOD_M30, 20, 0, ma_method, PRICE_CLOSE, i+1);
			ma20p2 = iMA(NULL, PERIOD_M30, 20, 0, ma_method, PRICE_CLOSE, i+2);
			
			
if (DayClose[] > DayOpen[] && WeekClose > Weekopen[] && MonthClose > MonthOpen[]) {CCC==ColorGreen};
else {
if (DayClose[] < DayOpen[] && WeekClose < Weekopen[] && MonthClose < MonthOpen[]) {CCC==ColorRed}};
else CCC==ColorNone;
*/

//--------------------------------------------------------
  //TimeToStr(CurTime());
  
  drawDP("DP",Pivot,DarkOrange,1);
  drawYHL("YH",YesterdayHigh,Magenta,1);
  drawYHL("YL",YesterdayLow,DodgerBlue,1);
  drawWP("WP",WeekPivot,WPC,1);
  drawWHL("WH",WeekHigh,Red,1);
  drawWHL("WL",WeekLow,MediumSeaGreen,1);
  drawMP("MP",MonthPivot,MPC,1);
  drawMHL("MH",MonthHigh,Maroon,1);
  drawMHL("ML",MonthLow,DarkGreen,1);
  ObjectsRedraw();
  
      drawPivotLine("W_S3 line",WS3,DarkGreen,1);
      drawPivotLine("W_S2 line",WS2,Green,2);
      drawPivotLine("W_S1 line",WS1,DodgerBlue,2);
      drawPivotLine("W_R1 line",WR1,Magenta,2);
      drawPivotLine("W_R2 line",WR2,Red,2);
      drawPivotLine("W_R3 line",WR3,Maroon,1);
      
      drawPivotLine2("M_S3 line",MS3,DarkGreen,1);
      drawPivotLine2("M_S2 line",MS2,Green,1);
      drawPivotLine2("M_S1 line",MS1,DodgerBlue,1);
      drawPivotLine2("M_R1 line",MR1,Magenta,1);
      drawPivotLine2("M_R2 line",MR2,Red,1);
      drawPivotLine2("M_R3 line",MR3,Maroon,1);
ObjectsRedraw();

   return(0);
}
void drawPivotLine(string lineName, double lineValue, color lineColor, int lineWidth)
{
if(ObjectFind(lineName) != 0) 
   {
      ObjectCreate(lineName, OBJ_TREND, 0, Time[0]+(CandleShift-7)*Period()*60, lineValue,Time[0]+(CandleShift-1)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 0);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
      ObjectSet(lineName, OBJPROP_RAY,   0);
   }
  else
   {
      ObjectMove(lineName, 0,Time[0]+(CandleShift-7)*Period()*60,lineValue);
      ObjectMove(lineName, 1,Time[0]+(CandleShift-1)*Period()*60,lineValue);
   }
  
}

void drawPivotLine2(string lineName, double lineValue, color lineColor, int lineWidth)
{
if(ObjectFind(lineName) != 0)
   {
      ObjectCreate(lineName, OBJ_TREND, 0, Time[0]+(CandleShift-7)*Period()*60, lineValue,Time[0]+(CandleShift-1)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 2);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
      ObjectSet(lineName, OBJPROP_RAY,   1);
   }
   else
   {
      ObjectMove(lineName, 0,Time[0]+(CandleShift-7)*Period()*60,lineValue);
      ObjectMove(lineName, 1,Time[0]+(CandleShift-1)*Period()*60,lineValue);
   }
}

void drawDP(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_D1,0), stop = Time[0];
 
if(ObjectFind(lineName) != 0 && Period()<1440)
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,Time[0]+(CandleShift+16)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 1);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
  //    ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
 /* else
   if (ObjectFind(lineName) != 0 && Period()== 240)
    { 
      ObjectCreate(lineName, Z, 0,start, lineValue,Time[0]+(CandleShift-1)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 0);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
      //ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0); 
        
   }
   */
   else   {
  ObjectMove(lineName, 0,start,lineValue);
  ObjectMove(lineName, 1,Time[0]+(CandleShift+16)*Period()*60,lineValue);
} 

 }
  
  void drawYHL(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_D1,1), stop = Time[0];   
if(ObjectFind(lineName) != 0 && Period()<1440)
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,stop, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 0);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
   //   ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
  else
   {
      ObjectMove(lineName, 0,start,lineValue);
      ObjectMove(lineName, 1,stop,lineValue);
       } 
  }
  
  
    void drawWP(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_W1,0), stop = Time[0];   
if(ObjectFind(lineName) != 0 && Period()<10080)
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,Time[0]+(CandleShift+16)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 1);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
   //   ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
  else
   {
      ObjectMove(lineName, 0,start,lineValue);
      ObjectMove(lineName, 1,Time[0]+(CandleShift+16)*Period()*60,lineValue);
      
   }
   
  }
   
   void drawWHL(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_W1,1), stop = Time[0];   
if(ObjectFind(lineName) != 0 && Period()<10080)
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,stop, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 0);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
   //   ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
  else
   {
      ObjectMove(lineName, 0,start,lineValue);
      ObjectMove(lineName, 1,stop,lineValue);
   }
  }

 void drawMP(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_MN1,0), stop = Time[0];   
if(ObjectFind(lineName) != 0 )
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,Time[0]+(CandleShift+16)*Period()*60, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 1);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
   //   ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
  else
   {
      ObjectMove(lineName, 0,start,lineValue);
      ObjectMove(lineName, 1,Time[0]+(CandleShift+16)*Period()*60,lineValue);
      
   }
   
  }
  
 void drawMHL(string lineName, double lineValue, color lineColor, int lineWidth)
{
   int Z= OBJ_TREND;
   int start = iTime(NULL,PERIOD_MN1,1), stop = Time[0];   
if(ObjectFind(lineName) != 0 && Period()<43200)
   {
      ObjectCreate(lineName, Z, 0,start, lineValue,stop, lineValue);
      ObjectSet(lineName, OBJPROP_STYLE, 0);
      ObjectSet(lineName, OBJPROP_WIDTH, lineWidth);
      ObjectSet(lineName, OBJPROP_COLOR, lineColor);
   //   ObjectSet(lineName, OBJPROP_BACK, 0);
      ObjectSet(lineName, OBJPROP_RAY,  0);
   }
  else
   {
      ObjectMove(lineName, 0,start,lineValue);
      ObjectMove(lineName, 1,stop,lineValue);
      
   }
  }
  
  
  /*{
   int Z= OBJ_TREND;
   int start, stop, startday;// = Time[1];
   if (Time[1] >= iTime(NULL,PERIOD_D1,0)) startday = iTime(NULL,PERIOD_D1,0);
  if ( startday<=iTime(NULL,0,WindowFirstVisibleBar())) {start= iTime(NULL,0,WindowFirstVisibleBar()); stop= Time[0]; }
   else {start= startday; stop= Time[0]; Z= OBJ_TREND;  }
   */